
/* Chrysalide - Outil d'analyse de fichiers binaires
 * dwarf.h - prototypes pour le support du format DWARF v3
 *
 * Copyright (C) 2015-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _FORMAT_DWARF_V3_DWARF_H
#define _FORMAT_DWARF_V3_DWARF_H


#include <glib-object.h>


#include "../../../core/formats.h"



#define G_TYPE_DWARFV3_FORMAT               g_dwarfv3_format_get_type()
#define G_DWARFV3_FORMAT(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_dwarfv3_format_get_type(), GDwarfV3Format))
#define G_IS_DWARFV3_FORMAT(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_dwarfv3_format_get_type()))
#define G_DWARFV3_FORMAT_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_DWARFV3_FORMAT, GDwarfV3FormatClass))
#define G_IS_DWARFV3_FORMAT_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_DWARFV3_FORMAT))
#define G_DWARFV3_FORMAT_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_DWARFV3_FORMAT, GDwarfV3FormatClass))


/* Format de débogage DWARF v3 (instance) */
typedef struct _GDwarfV3Format GDwarfV3Format;

/* Format de débogage DWARF v3 (classe) */
typedef struct _GDwarfV3FormatClass GDwarfV3FormatClass;


/* Indique le type défini pour un format de débogage DWARF v3. */
GType g_dwarfv3_format_get_type(void);

/* Prend en charge un nouveau format DWARF (v3). */
GBinFormat *g_dwarfv3_format_new(GBinContent *, GExeFormat *, GtkStatusStack *);



#endif  /* _FORMAT_DWARF_V3_DWARF_H */
